---
title: XPathResult.resultType
slug: Web/API/XPathResult/resultType
tags:
  - API
  - DOM XPath API
  - Property
  - Reference
  - XPath
  - XPathResult
---
<div>{{APIRef("DOM XPath")}}</div>

<p>The read-only <strong><code>resultType</code></strong> property of the {{domxref("XPathResult")}} interface represents the type of the result, as defined by the type constants.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>resultType</var> = <var>result</var>.resultType;
</pre>

<h3 id="Return_Value">Return value</h3>

<p>An integer value representing the type of the result, as defined by the <a href="#">type constants</a>.</p>

<h2 id="Constants">Constants</h2>

<table class="standard-table">
 <thead>
  <tr>
   <td class="header">Result Type Defined Constant</td>
   <td class="header">Value</td>
   <td class="header">Description</td>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>ANY_TYPE</code></td>
   <td><code>0</code></td>
   <td>A result set containing whatever type naturally results from evaluation of the expression. Note that if the result is a node-set then <code>UNORDERED_NODE_ITERATOR_TYPE</code> is always the resulting type.</td>
  </tr>
  <tr>
   <td><code>NUMBER_TYPE</code></td>
   <td><code>1</code></td>
   <td>A result containing a single number. This is useful for example, in an XPath expression using the <code>count()</code> function.</td>
  </tr>
  <tr>
   <td><code>STRING_TYPE</code></td>
   <td><code>2</code></td>
   <td>A result containing a single string.</td>
  </tr>
  <tr>
   <td><code>BOOLEAN_TYPE</code></td>
   <td><code>3</code></td>
   <td>A result containing a single boolean value. This is useful for example, in an XPath expression using the <code>not()</code> function.</td>
  </tr>
  <tr>
   <td><code>UNORDERED_NODE_ITERATOR_TYPE</code></td>
   <td><code>4</code></td>
   <td>A result node-set containing all the nodes matching the expression. The nodes may not necessarily be in the same order that they appear in the document.</td>
  </tr>
  <tr>
   <td><code>ORDERED_NODE_ITERATOR_TYPE</code></td>
   <td><code>5</code></td>
   <td>A result node-set containing all the nodes matching the expression. The nodes in the result set are in the same order that they appear in the document.</td>
  </tr>
  <tr>
   <td><code>UNORDERED_NODE_SNAPSHOT_TYPE</code></td>
   <td><code>6</code></td>
   <td>A result node-set containing snapshots of all the nodes matching the expression. The nodes may not necessarily be in the same order that they appear in the document.</td>
  </tr>
  <tr>
   <td><code>ORDERED_NODE_SNAPSHOT_TYPE</code></td>
   <td><code>7</code></td>
   <td>A result node-set containing snapshots of all the nodes matching the expression. The nodes in the result set are in the same order that they appear in the document.</td>
  </tr>
  <tr>
   <td><code>ANY_UNORDERED_NODE_TYPE</code></td>
   <td><code>8</code></td>
   <td>A result node-set containing any single node that matches the expression. The node is not necessarily the first node in the document that matches the expression.</td>
  </tr>
  <tr>
   <td><code>FIRST_ORDERED_NODE_TYPE</code></td>
   <td><code>9</code></td>
   <td>A result node-set containing the first node in the document that matches the expression.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>The following example shows the use of the <code>resultType</code> property.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;XPath example&lt;/div&gt;
&lt;div&gt;Is XPath result a node set: &lt;output&gt;&lt;/output&gt;&lt;/div&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">var xpath = "//div";
var result = document.evaluate(xpath, document, null, XPathResult.ANY_TYPE, null);
document.querySelector("output").textContent =
  result.resultType &gt;= XPathResult.<code>UNORDERED_NODE_ITERATOR_TYPE &amp;&amp;
  </code>result.resultType &lt;= XPathResult.<code>FIRST_ORDERED_NODE_TYPE</code>;
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 400, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 XPath", "xpath.html#XPathResult-resultType", "XPathResult.resultType")}}</td>
   <td>{{Spec2("DOM3 XPath")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.XPathResult.resultType")}}</p>
</div>
